//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_navigate.cpp
//
/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>
#include "plbot_api.h"  // me

int parameters[MAX_PARM];

float angle_cos_30[7] = {1, 0.87,0.5,0,-0.5,-0.87,-1};
float angle_sin_30[7] = {0,0.5,0.87,1,0.87,0.5,0};

bool UnstuckCode(player_t *pBot, Vector &vecAvoid)
{
   edict_t *pent = NULL;
   player_t *pPlayer = NULL;
   Vector vecSrc = pBot->pEdict->v.origin;

   //Search for players in unstuck distance
   while (pent = UTIL_FindEntityInSphere(pent, vecSrc, bunstuck))
   {
      //If we have found bot lets check few cases
      if (!FClassnameIs( pent, "player"))
         continue;
      //Skip self and unvisible objects
      if ((pent == pBot->pEdict) || (pent->v.effects & EF_NODRAW) || (!IsAlive(pent)))
         continue;

      pPlayer = GET_EPLAYERPOINTER(pent);
      //Skip non bot players
      if (!(pPlayer->flags & FL_FAKECLIENT))
         continue;
      //Skip users
      if (pBot->pHelpme == pPlayer->pEdict)
         continue;
      //Run off from another player
      vecAvoid = vecAvoid - (pent->v.origin - vecSrc).Normalize()*bsensf*bprio*3;

      if ((pent->v.origin - vecSrc).Length() < bunstuck / 2)
         return TRUE;
   }
   //Haven't found so don't check for a while coz probably is not standing near
   if (!pPlayer)
      pBot->check_stuck_time = gpGlobals->time + RANDOM_FLOAT(0.20 , 0.40);

   return FALSE;
}

bool FoundBreakable(player_t *pBot)
{
   Vector vecSearch = pBot->pEdict->v.origin;

   //Find breakable function
   edict_t *pFoundItem = Finditem(pBot, vecSearch, "func_breakable", CLIENT_ALLTEAMS, 64, TRUE);

   //We have found nothing so return FLASE
   if ((pFoundItem == NULL) || (pFoundItem->v.health > 100))
      return FALSE;

   //Get origin
   Vector vecLadPos = VECBMODELORIGIN(pFoundItem);

   //Yes we have found and item is visible
   if (FVisible(vecLadPos, pBot->pEdict) == FALSE)
      return FALSE;

   Vector vecAim = vecLadPos - vecSearch;

   //Point gun at item
   pBot->pEdict->v.v_angle = BotPointAt(pBot, vecAim, TRUE);

   //Shoot at enemy (well this fix small problem when
   //aiming and actual body direction aren't thesame
   if (InFieldOfView( pBot, vecAim , pBot->pEdict->v.angles.y) < 4)
      BotFireWeapon(500, pBot, 0); //500 is a fake distance

   return TRUE;
}

/*
Vector FoundLadder(player_t *pBot, Vector vecAvoid)
{
 TraceResult trEnd; Vector vecSearch = pBot->pEdict->v.origin; bool haveground = FALSE;
 
 edict_t *pFoundItem = Finditem(pBot, vecSearch, "func_ladder", CLIENT_ALLTEAMS, 64, TRUE);
 
 if (!pFoundItem) return vecAvoid;
 
 Vector vecCheck = vecSearch + gpGlobals->v_forward * 8;
 Vector vecDown = vecCheck + gpGlobals->v_up * -50;
 
 UTIL_TraceLine( vecSearch, vecCheck,dont_ignore_monsters, dont_ignore_glass,
  pBot->pEdict->v.pContainingEntity, &trEnd);
 
 if (trEnd.flFraction < 1.0) //Our vector on 8 units hit wall so we must be near wall
  //In this case we are on bottom of ladder
  haveground = TRUE;
 
 UTIL_TraceLine( vecCheck, vecDown,dont_ignore_monsters, dont_ignore_glass,
  pBot->pEdict->v.pContainingEntity, &trEnd);
 
 if (trEnd.flFraction < 1.0) //We hit ground so we are on ground
  haveground = TRUE;
 
 //Get origin
 Vector vecLadPos = VecBModelOrigin(pFoundItem);
 //Reset to player height
 vecLadPos.z = vecSearch.z;
 //Apply to whole body
 vecAvoid = (vecLadPos - vecSearch).Normalize()*(float)bsensf*1.5;
 pBot->ideal_body = vecAvoid.y;
 
 //Check if on ladder
 if (!IsOnLadder(pBot))
 {
  if (haveground)
   //We have ground under player so go up
   pBot->ladder_dir = LADDER_UP;
  else
   pBot->ladder_dir = LADDER_DOWN; //else go down
 }
 
 //Set correct going direction
 if (pBot->ladder_dir == LADDER_DOWN)
  pBot->avoid_angle.x = 60; //Go down
 else
  pBot->avoid_angle.x = -60; //Go up
 
 return vecAvoid;
}
*/

bool CheckIfCanJumpWhole(player_t *pBot)
{
   TraceResult trEnd, trEnd2;

   Vector v_forward, v_right,v_up;
   ANGLEVECTORS( pBot->avoid_angle, v_forward, v_right,v_up );
   //Set vectors to player avoid direction
   //UTIL_MakeVectors(pBot->avoid_angle);

   //Make one forward vector and at its end to down
   Vector vecSrc = pBot->pEdict->v.origin;
   Vector vecCheck = vecSrc + v_forward * 2;
   Vector vecDown = vecCheck + v_up * -64;

   UTIL_TraceLine( vecCheck, vecDown, ignore_monsters, dont_ignore_glass,
                   pBot->pEdict->v.pContainingEntity, &trEnd);

   //Is stucking so we have got ground return FALSE
   if (trEnd.flFraction < 1.0)
      return FALSE;

   //Make one 80 long forward and at its end to down
   vecCheck = vecSrc + v_forward * 80;
   vecDown = vecCheck + v_up * -64;

   UTIL_TraceLine( vecCheck, vecDown, ignore_monsters, dont_ignore_glass,
                   pBot->pEdict->v.pContainingEntity, &trEnd2);

   //Make one 192 long and 50 to down
   vecCheck = vecSrc + v_forward * 192;
   vecDown = vecCheck + v_up * -64;

   UTIL_TraceLine( vecCheck, vecDown, ignore_monsters, dont_ignore_glass,
                   pBot->pEdict->v.pContainingEntity, &trEnd);

   //If both of them are free don't jump
   if ((trEnd.flFraction >= 1.0) && (trEnd2.flFraction >= 1.0))
      return FALSE;

   //We can jump
   return TRUE;
}

bool CheckIfCanJump(player_t *pBot, IGNORE_MONSTERS igmon)
{
   TraceResult trEnd;

   Vector v_forward, v_right,v_up;
   ANGLEVECTORS( pBot->avoid_angle, v_forward, v_right, v_up );
   //Set vectors to player avoid direction
   //UTIL_MakeVectors(pBot->avoid_angle);

   //One vector forward 10 units down and 96 forward
   Vector vecSrc = pBot->pEdict->v.origin + Vector(0,0,-12);
   Vector vecCheck = vecSrc + v_forward * 92;

   //Do we have ignore player or not?
   UTIL_TraceLine( vecSrc, vecCheck, igmon, dont_ignore_glass, pBot->pEdict->v.pContainingEntity, &trEnd);

   //This is free space so not needed jumping
   if (trEnd.flFraction >= 1.0)
      return FALSE;

   //Make one vector 24 units above and 192 forward
   vecSrc = pBot->pEdict->v.origin + Vector(0,0,24);
   vecCheck = vecSrc + v_forward * 192;

   UTIL_TraceLine( vecSrc, vecCheck, dont_ignore_monsters, dont_ignore_glass, pBot->pEdict->v.pContainingEntity, &trEnd);

   //It's blocked so don't jump
   if (trEnd.flFraction < 1.0)
      return FALSE;

   //Now trace down 128 units at last vector end
   vecSrc = vecCheck;
   vecCheck = vecSrc + v_up * -128;

   UTIL_TraceLine( vecSrc, vecCheck, ignore_monsters, dont_ignore_glass,
                   pBot->pEdict->v.pContainingEntity, &trEnd);

   //Space is free so there is to high
   if (trEnd.flFraction >= 1.0)
      return FALSE;

   //It's less then 28 long so it must be stairs
   if ((trEnd.vecEndPos - vecCheck).Length() < 32 )
      return FALSE;

   //Can jump through obstacle
   return TRUE;
}

/*
bool CheckIfCanDuck(player_t *pBot)
{
 TraceResult trEnd;
 Vector vecSrc = pBot->pEdict->v.origin + gpGlobals->v_forward*4;
 
 UTIL_MakeVectors(pBot->avoid_angle);
 
 //Check if we have got something above
 UTIL_TraceLine(vecSrc, vecSrc + gpGlobals->v_up*46,dont_ignore_monsters, dont_ignore_glass,
  pBot->pEdict->v.pContainingEntity, &trEnd);
 
 if (trEnd.flFraction >= 1.0) return FALSE;
 
 vecSrc = pBot->pEdict->v.origin;
 
 //Check if we have got ground under
 UTIL_TraceLine( vecSrc, vecSrc + gpGlobals->v_up*-48,dont_ignore_monsters, dont_ignore_glass,
  pBot->pEdict->v.pContainingEntity, &trEnd);
 
 //Yesy! We have so can't duck because we aren't jumping
 if (trEnd.flFraction < 1.0) return FALSE;
 
 //Can duck
 return TRUE;
}
*/

bool NotLastGoal(player_t *pBot, edict_t *pNode)
{
   //Loop through array and check if there alrady exist this node
   for (int index = 0; index < blnodes; index++)
   {
      if (pBot->lastNodes[index] == pNode) //Yes we have found it
         return FALSE; //No this nodes were used
   }

   return TRUE;
}

void NullLastGoals(player_t *pBot)
{
   for (int index_nodes = 0; index_nodes < blnodes; index_nodes++)
      pBot->lastNodes[index_nodes] = NULL;
}

//Check if in direction of selected object is in enought distance to go there
bool NavigateCustomDir(player_t *pBot, Vector vecSrc, Vector vecDest, Vector &vecAvoid,  float dist, float sens)
{
   TraceResult trEnd, trDown;
   Vector vecDestination = UTIL_VecToAngles(vecDest - vecSrc);
   vecDestination.x = 0; //Reset horizontal angle
   vecDestination.z = 0; //Reset veritical angle

   Vector v_forward, v_right,v_up;
   ANGLEVECTORS( vecDestination, v_forward, v_right, v_up );
   //UTIL_MakeVectors(vecDestination);

   //Make vector in that direction on distance specified by bsenf and bsenss
   Vector vecMainDest = vecSrc + v_forward*bsensf*dist + v_up*bsensf*pBot->groundAngle;//tan(bangle*0.0175);
   UTIL_TraceLine( vecSrc, vecMainDest, dont_ignore_monsters, dont_ignore_glass, pBot->pEdict->v.pContainingEntity, &trEnd);
   //Now make the vector directed in ground from end of above vector
   Vector vecDestDown = vecMainDest + v_up * -bheight;
   UTIL_TraceLine(vecMainDest , vecDestDown, ignore_monsters, dont_ignore_glass, pBot->pEdict->v.pContainingEntity, &trDown);

#ifdef MY_DEBUGE_MODE
   //For development
   if ((pBot->currentNodes) && (vecDest == pBot->currentNodes->v.origin))
   {
      if ((developme & 8) && (pBot->planedGoal))
         DrawBeam(listenserver_edict, vecSrc, VECBMODELORIGIN(pBot->planedGoal) , 0, 0, 255);

      if (developme & 2)
      {
         DrawBeam(listenserver_edict, vecSrc, vecMainDest, 255, 255, 0);
         DrawBeam(listenserver_edict, vecMainDest, vecDestDown, 255, 255, 0);
      }
   }
#endif

   if (((trEnd.flFraction >= 1.0 && trDown.flFraction < 1.0) || (FClassnameIs( trEnd.pHit, "hostage_entity" ))) ||
         (FClassnameIs( trEnd.pHit, "func_door" )) || (FClassnameIs( trEnd.pHit, "func_door_rotating" )))
   {

#ifdef MY_DEBUGE_MODE
      //For development
      if ((developme & 1) && (pBot->currentNodes) && (vecDest == pBot->currentNodes->v.origin))
         DrawBeam(listenserver_edict, vecSrc, vecDest , 0, 0, 255);
#endif

      vecAvoid = vecAvoid + (vecDest - vecSrc).Normalize()*bsensf*sens;
      return TRUE; //Our custom dir was succesfull accepted....
   }

   return FALSE; //It's to high or this dir is blocked return FALSE
}

//Here is my main algorithm which protect bot from wall
//And many other thing which control bots moving
Vector NavigateMe(player_t *pBot)
{
   edict_t *pEdict = pBot->pEdict, *pent = NULL;
   double x=0, y=0, z=0;
   Vector vecDest, vecDestDown;
   TraceResult trEnd,trDown;
   bool notblocked = TRUE, CanChooseLongest = TRUE, follow_nodes = TRUE;
   float hp_distance;
   int warning = 0;

   UTIL_VecToAngles(pBot->avoid_angle); //Make angles
   pBot->avoid_angle.x = 0; //Reset horizontal angle

   Vector v_forward, v_right,v_up;
   ANGLEVECTORS( pBot->avoid_angle, v_forward, v_right, v_up );
   //UTIL_MakeVectors(pBot->avoid_angle); //Reset gpGlobals to avoid_angle

   Vector vecSrc = GetGunPosition(pBot->pEdict) + Vector (0,0,-36+blevel);

   //init here main direction vector
   Vector vecAvoid = vecSrc + v_forward - vecSrc;
   Vector vecAproxDirect = vecAvoid;

   //Get angle (tangens) of ground
   Vector vecCheckAngle = pBot->pEdict->v.origin + v_forward*36;
   Vector vecDownAngle = vecCheckAngle - v_up*36; //Always from thisame level as source
   UTIL_TraceLine( vecCheckAngle, vecDownAngle, ignore_monsters, dont_ignore_glass, pEdict->v.pContainingEntity, &trEnd);
   //Save angle
   pBot->groundAngle = (36 - (vecCheckAngle - trEnd.vecEndPos).Length())/36;

   //There is my stuff to avoid wall
   //Sum bunch of vectors to get the best direction
   for (int i=0; i<7; i++)// (-1 to 6)
   {
      //Generate direction
      x=bsenss*angle_cos_30[i];
      y=bsensf*angle_sin_30[i];
      z=y*pBot->groundAngle;
      vecDest = vecSrc + v_forward*y + v_right*x + v_up*z;

      //Make vector in that direction on distance specified by bsenf and bsenss
      UTIL_TraceLine( vecSrc, vecDest, dont_ignore_monsters, dont_ignore_glass, pEdict->v.pContainingEntity, &trEnd);

      //Now make the vector directed in ground from end of above vector
      vecDestDown = vecDest + v_up * -bheight;
      UTIL_TraceLine(vecDest, vecDestDown, ignore_monsters, dont_ignore_glass, pEdict->v.pContainingEntity, &trDown);

      //If first vector is free and second hit to ground add
      //this vector to the main direction. Also do not obey hostages
      if (((trEnd.flFraction >= 1.0 && trDown.flFraction < 1.0) || (FClassnameIs( trEnd.pHit, "hostage_entity" )))
            || (FClassnameIs( trEnd.pHit, "func_door" )) || (FClassnameIs( trEnd.pHit, "func_door_rotating" )))
      {
         //If center down directed vector if blocked dont use TheLongestCorridor Algorithm
         if ((i==3) &&((trEnd.vecEndPos - trDown.vecEndPos).Length() < 48))
            CanChooseLongest = FALSE;

         //Well if it is the first vector say us that he is not blocked
         if (i==0)
            notblocked = FALSE;
         //Other vectors also are not blocked
         else if (i<6)
            notblocked = TRUE;

         //Well if there was no message from any other vectors than first about
         //been blocked warn oposite vector do not add to the main direction
         if ((i==6) && (!notblocked))
         {
            warning++;
            continue;
         }

#ifdef MY_DEBUGE_MODE
         //Only first bot and when in current node
         if (developme & 4)
         { //For development
            DrawBeam(listenserver_edict, vecSrc, vecDest, 255, 0, 0);
            DrawBeam(listenserver_edict, vecDest, vecDestDown, 0, 0, 255);
         }
#endif

         //Add this vector to the main direction
         vecAvoid = vecAvoid + (vecDest - vecSrc);
      }
      else
      {
         //The cases were not done so don't add this vector and add one point to the warning message
         warning++;
      }
   }

   //Noramlize vector for futher usage...
   vecAvoid = vecAvoid.Normalize()*bsensf;
   //Well there is warning message. Almost all vector are blocked so add one to the back
   if (warning > 2)
      vecAvoid = vecAvoid + (vecSrc - v_forward*bsensf*2 - vecSrc);

   /*//TheLongestCorridor Algorithm. Very similar to this above but works with longer vectors
   //and sum all vector to find the best vector which will be added to main direction
   if ((!pBot->pBotEnemy) && (CanChooseLongest) && (CPUusage(5)) && !(pBot->user_action & USER_FOLLOWME))
   {
    for (int i=1; i<6; i++)
    {
     x=2048*cos(DEG_30*i); y=2048*sin(DEG_30*i); //z=y*tan(DEG_5);

       vecDest = vecSrc + v_forward*y + v_right*x; //+ v_up*z;
       UTIL_TraceLine( vecSrc, vecDest,dont_ignore_monsters, dont_ignore_glass, pEdict->v.pContainingEntity, &trEnd);
       vecAproxDirect = vecAproxDirect + (trEnd.vecEndPos - vecSrc);
    }

       //Add longest normalized vector to main direction
       vecAvoid = vecAvoid + vecAproxDirect.Normalize()*bsensf*bprio*2; //Set power of aprox. dir.
   }*/

   if (pBot->pBotEnemy && !(pBot->user_action & USER_FALLBACK))
   {
      //We have got enemy and when he is not visible navigate with caution
      if ((warning < 2) && !FVisible(pBot->pBotEnemy->v.origin, pEdict))
         NavigateCustomDir(pBot, vecSrc, pBot->pBotEnemy->v.origin, vecAvoid,  1, 2);

      follow_nodes = FALSE; //Don't allow follow for nodes
   }
   else if ((pBot->user_action & USER_FOLLOWME) && (pBot->user_gogogo_time < gpGlobals->time))
   {
      follow_nodes = FALSE; //Don't allow follow for nodes
      //If user is visible set direction on him
      if (FVisible( pBot->pHelpme->v.origin, pEdict))
         NavigateCustomDir(pBot, vecSrc, pBot->pHelpme->v.origin, vecAvoid,  1, 2);
      else if (warning < 3) //Else navigate with caution
         NavigateCustomDir(pBot, vecSrc, pBot->pHelpme->v.origin, vecAvoid,  1, 2);
   }
   else if ((pBot->user_action & USER_HOLD) && (!bombplanted))
   {
      follow_nodes = FALSE; //Don't allow follow for nodes
      //Here bot guard one area
      hp_distance = (pBot->vecHoldPosition - vecSrc).Length2D();

      //If we visible guard area and dist is longer than 176 than try to back
      if (FVisible( pBot->vecHoldPosition, pEdict))
      {
         if (hp_distance > 176)
            NavigateCustomDir(pBot, vecSrc, pBot->vecHoldPosition, vecAvoid,  1, 1);
      }
      else if (warning < 3) //When not visible try to back with caution
         NavigateCustomDir(pBot, vecSrc, pBot->vecHoldPosition, vecAvoid,  1, 1);
   }
   else //Navigate
   {
      //Bot has found ladder so go on it
      // vecAvoid = FoundLadder(pBot, vecAvoid);
   }


   //Search for hostages and take them if needed...
   if ((Maptype == CS_MAP) && (pBot->player_team & CLIENT_CT))
   {
      if (BotGetHostages(pBot, vecAvoid, 4))
         follow_nodes = FALSE; //Don't allow follow for nodes
   }
   //Search for bomb planted or droped...
   if (Maptype == DE_MAP)
   {
      if (BotGetToC4(pBot, vecAvoid, 3))
         follow_nodes = FALSE; //Don't allow follow for nodes
   }
   //Search for bombzones!!!
   if ((Maptype == DE_MAP) && (pBot->player_team & CLIENT_TERRORIST))
   {
      if (BotGetToBombZone(pBot, vecAvoid, 4))
         follow_nodes = FALSE; //Don't allow follow for nodes
   }

   //Avoid other teammates
   if (pBot->check_stuck_time < gpGlobals->time)//If someone haven't blocked checking
   {
      if (UnstuckCode(pBot, vecAvoid))
         follow_nodes = FALSE; //Don't allow follow for nodes
   }
   //If better weapon is lying on ground pick up it

   if ((pBot->bot_see_enemy_time < gpGlobals->time + 2) && (pBot->player_team != CLIENT_VIP))
   {
      if (FindBestWeaponOnGround(pBot, vecAvoid, 2))
         follow_nodes = FALSE; //Don't allow follow for nodes
   }

   if (!follow_nodes || !pBot->planedGoal)
      return vecAvoid; //We cant go farther because one of priority was saw...

   //Small stuff to find the shortes way to the goal... (a bit crappy but works)
   if (pBot->currentNodes)
   { //Navigate with actual node
      Vector vecCurrentNodes = pBot->currentNodes->v.origin;
      //If user is visible set direction on him
      if (FVisible(vecCurrentNodes , pEdict))
      {
         Vector vecPlanedGoal = VECBMODELORIGIN(pBot->planedGoal);
         //If we have reached our goal remove it from list
         if (((vecPlanedGoal - vecSrc).Length() < minway*4) && (FVisible(vecPlanedGoal, pEdict)))
            pBot->planedGoal = NULL;

         if ((vecCurrentNodes - vecSrc).Length() < minway)
         {
            //Save last node as used
            for (int index_node = blnodes - 1; index_node > 0; index_node--)
               pBot->lastNodes[index_node] = pBot->lastNodes[index_node - 1];
            //Add new node to list of used nodes
            pBot->lastNodes[0] = pBot->currentNodes;
            //Reset current
            pBot->currentNodes = NULL; //Clear current goal
         }
         else
            NavigateCustomDir(pBot, vecSrc, vecCurrentNodes, vecAvoid,  2, bprio);
      }
      else
         pBot->currentNodes = NULL; //We have lost our goal from eyes
   }
   else if (pBot->planedGoal && CPUusage(1))
   {//Make some random and decrease CPU usage...
      edict_t *pFoundNode = NULL;
      edict_t *pWinnerNode = NULL;
      float best_distance = 9999.0; //Worst distance
      float best_high = 9999.0; //Worst high

      //Go through all nodes and find the best one
      //while (pFoundNode = UTIL_FindEntityByClassname(pFoundNode, "navigation_node"))
      while (pFoundNode = UTIL_FindEntityInSphere(pFoundNode, vecSrc, maxway))
      {
         //If we have found bot lets check few cases
         if (!FClassnameIs( pFoundNode, "info_node"))
            continue;

         Vector vecNode = pFoundNode->v.origin; //Get origin of node

         UTIL_TraceLine( vecSrc, vecNode, ignore_monsters, ignore_glass, pEdict->v.pContainingEntity, &trEnd);
         //If line not estabilished and there is no doors so object is truly not reachable
         if ((trEnd.flFraction < 1.0) && (!FClassnameIs( trEnd.pHit, "func_door" )) && (!FClassnameIs( trEnd.pHit, "func_door_rotating" )))
            continue;

         float distance = (vecNode - VECBMODELORIGIN(pBot->planedGoal)).Length();
         float high = abs(vecNode.z - vecSrc.z);

         //New node can't be alrady used, must be as near as it possible to object
         //And almost at this same level as player who serach for goal
         if (NotLastGoal(pBot, pFoundNode) && (best_distance + 128 > distance) && (best_high + 256 > high))
         {
            best_high = high;
            best_distance = distance; //Save shortes distance
            pWinnerNode = pFoundNode; //Save nodes edict
         }
      }

      //Set node (even if not found) to currentGoal
      pBot->currentNodes = pWinnerNode;
   }

   return vecAvoid;
}
